{\rtf0\ansi{\fonttbl\f0\fmodern Courier;\f1\ftech Symbol;\f3\fmodern Ohlfs;}
\margl40
\margr40
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 //\
//
\i 	
\b FILENAME
\b0 :	
\b\i0 Inspector.h \

\b0 //
\i 	
\b SUMMARY
\b0 :	
\b\i0 Header for a NeXTSTEP-style inspector using <Inspectable>\

\b0 //	
\b\i SUPERCLASS
\b0 :
\i0 	
\b Object:Inspector
\b0 \
//	
\b\i PROTOCOLS
\b0 :
\i0 	
\b <Inspectable>
\b0 \
//	
\b\i INTERFACE
\b0 :
\i0 	
\b Inspector.nib
\b0 \
//	
\b\i AUTHOR
\b0 :		
\b\i0 Rohit Khare
\b0 \
//	
\b\i COPYRIGHT
\b0 :	
\f1\i0 
\f0\b 1993,94 California Institure of Technology, eText Project\

\b0 //\
//	
\b\i Description
\b0\i0 \
// 		The Inspector coordinates with one <Inspectable> object at a time\
// to manage a polymorphic UI panel. The <Inspectable> object has to provide\
// 1) a list of the different inspectors it has and 2) each of those\
// inspectors, on demand. The list is a char ** array, with the first entry\
// defined as the"default" or primary inspector.\
// \
// NS: This class is designed as owner of a NIB. It will display "No Inspector"\
// if there's nothing inspectable, or else, a popup (loaded with that char**),\
// and callbacks to swap in the appropriate view at the appropriate time.\
//\
//	
\b\i History
\b0\i0 \
//	10/30/93:	
\b Added refresh: (see setDocPath in eTDocInfo)
\b0 \
//	10/30/93:	
\b Removed invalidate: (Obsolete, not called)
\b0 \
//	10/30/94:	
\b Modified to implement <InspectorTarget> protocol.
\b0 \
//	09/21/94:	
\b Revamped for eText5; cleanup.
\b0 \
//	02/04/94:	
\b Modified invalidate to "tunnel" through to display etDocInfoUI
\b0 \
//	01/12/94:	
\b Reworked header file dependency
\b0 \
//	08/22/93:	
\b Added invalidate:
\b0 \
//	08/18/93:	
\b Created. Derived almost wholly from Version 1.0
\b0 \
//	
\i Version 1.0 tracking notes:
\i0 \
//	06/29/93: 	
\b Added conformance for touch (currentDoc)
\b0 \
// 	06/27/93: 	
\b Created (Rohit Khare)
\b0 \
//\
//	
\b Imported Interfaces
\b0 \
//\
	#import "
\b eTextKernel.h
\b0 "\
	#import	"
\b Inspectable.h
\b0 "\
\

\i @interface Inspector:Object <Inspectable> \{\

\i0 //\
//	
\b Instance Variables
\b0 \
//\
	//	
\i Objects from InterfaceBuilder
\i0 \
	Panel	*
\b panel
\b0 ;		// 
\i From IB, the larger panel
\i0 .\
	Button	*
\b cover
\b0 ;		// 
\i the popup trigger
\i0 \
	id		
\b popup
\b0 ;		// 
\i the popup\
	
\i0 \
	// 	
\i The inspector's actual state
\i0 \
	id		
\b current
\b0 ;\
	id		
\b currentTarget
\b0 ;\
	View	*
\b currentView
\b0 ;\
	char	*
\b currentType
\b0 ;\
	\
	//	
\i These are for the inspector's self-inspecting "No Selection"
\i0 \
	Panel	*
\b invalidPanel
\b0 ;\
	View	*
\b invalidView
\b0 ;\
	Panel	*
\b infoPanel
\b0 ; \
	View	*
\b infoView
\b0 ;\
	char	**
\b typesForInspector
\b0 ;	\
	\}\
	\
//\
//	
\b Class Management
\b0 \
//\
	- 
\b init
\b0 ;\
	- 
\b free
\b0 ;		\
	- 
\b awakeFromNib
\b0 ;\
\
//\
//	
\b User Interface
\b0 \
//\
	- 
\b showInspector
\b0 ;\
	- 
\b swap
\b0 :sender;\
\
//\
//	
\b Public Inspector API
\b0 \
//\
	- 
\b inspect
\b0 : 
\b newObj
\b0 ; // 
\i Can be 
\i0 <
\b Inspectable
\b0 >
\i  or 
\i0 <
\b InspectableTarget
\b0 >
\i ;
\i0 \
	// - 
\b invalidate
\b0 ; 	// 
\i Obsolete interface; generate warning on use
\i0 \
	- 
\b currentObj
\b0 ;\
	- 
\b makeFirstResponder
\b0 :aView;\
	- 
\b refresh
\b0 ;			// 
\i Send an activateInspector: for the current panel
\i0 \
\
//\
//	
\b Private Inspector API
\b0 \
//\
	- 
\b freeze
\b0 ;\
	- 
\b thaw
\b0 ;\
	\

\i @end
}
