///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	MailTo.h 
//	SUMMARY:	Interface for a mailto:URL -like device
//	SUPERCLASS:	MailTo:eTImage:Object
//	INTERFACE:	None
//	PROTOCOLS:	<Annotation,HTMDSupport,ASCIISupport,LaTeXSupport,Tool,
//				InspectableTarget>
//	AUTHOR:		Rohit Khare and Tom Zavisca
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		Does its job by holding subject & address and yelling at NXApp.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	10/30/94:	Modified to support <InspectableTarget>
//	07/20/94:	Converted over to eTImage/eTImageComponent. (rk)
//  07/07/94:	Converted to subclass of ImageAnnotation
//  07/04/94:	Minimal Creation
///////////////////////////////////////////////////////////////////////////////

#import "eTextKernel.h"
#import "../eTImage.subproj/eTImage.h"
#import "MailToUI.h"

@interface MailTo:eTImage <Annotation, Tool, ASCIISupport, HTMDSupport,LaTeXSupport>
{
	NXAtom	address, subject;
}

- sendMail: sender;
- setSubject: (NXAtom) newSubject;
- setAddress: (NXAtom) newAddress;
- (NXAtom) subject;
- (NXAtom) address;
@end