///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTFileLinkUI.h 
//	SUMMARY:	Interface definition for FileLink UI
//	SUPERCLASS:	Object
//	INTERFACE:	None
//	PROTOCOLS:	<Inspectable>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		Displays (1) file/directory and allows the user to set an exec string.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	08/06/94:	Added symbolic linking support.
//  07/03/94:	Created. Mimics RTFD file inclusions.
///////////////////////////////////////////////////////////////////////////////

#import "eTFileLink.h"

@interface eTFileLinkUI:eTImageUI <Inspectable>
{
    id	execField;
    id	execSwitch;
    id	filenameField;
    id	filenameSwitch;
    id	linkPanel;
    id	linkView;
	id	theLink;
	id	symlinkSwitch;
}

+ new;
- enableExec:sender;
- setAnnotation:sender;
- setExec:sender;
- forceSymlink:sender;
@end