///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTLink.h 
//	SUMMARY:	Interface for link buttons in eText documents
//	SUPERCLASS:	Object
//	INTERFACE:	None
//	PROTOCOLS:	<Annotation,HTMDSupport,ASCIISupport,LaTeXSupport,Tool,
//				InspectableTarget>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		Does its job by holding doc/anchorIDs and yelling at NXApp.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	10/30/94:	Modified to support <InspectableTarget>
//	07/21/94:	Revamped for PR1 and eTImage[Component] support
//	07/09/94:	URLRep added by RK and TRZ
//	07/04/94:	Added image support
//  06/17/94:	HTMDSupport added. RK and TRZ
//	02/04/94:	Created. First actual implementation.
///////////////////////////////////////////////////////////////////////////////

#import "eTextKernel.h"
#import "Bookmark.subproj/Bookmark.h"
#import "eTImage.subproj/eTImage.h"
#import "eTImage.subproj/eTImageUI.h"
#import "eTLinkUI.h"

@interface eTLink:eTImage <Annotation, Tool, ASCIISupport, HTMDSupport, LaTeXSupport>
{	long	anchorID;
	long	docID;
	etfLink	theLink;
}

- initFromFile: (const char *) theFile;
- (NXAtom)anchorTitle;
- (NXAtom)anchorID;
- (NXAtom)docTitle;
- (NXAtom)docID;
@end