///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTLiteral.h 
//	SUMMARY:	Interfacefor escaped sequence specific for different formats
//	SUPERCLASS:	eTImage
//	INTERFACE:	None
//	PROTOCOLS:	<Annotation,HTMDSupport,ASCIISupport,LaTeXSupport,Tool,
//				InspectableTarget>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//  DESCRIPTION
//		Container of rtf comment, owner, and last-modified date strings.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	10/30/94:	Modified to support <InspectableTarget>
//	07/25/94:	Added ISINDEX subclass as an investigation into "shortcut"s
//  07/24/94:	Birth
///////////////////////////////////////////////////////////////////////////////

#import "../eTextKernel.h"
#import "../eTImage.subproj/eTImage.h"
#import "../eTImage.subproj/eTImageUI.h"
#import "eTLiteralUI.h"

@interface eTLiteral:eTImage <Tool,Annotation,ASCIISupport,CSupport,HTMDSupport,LaTeXSupport> 
{
	char 	*theReps[NUM_FMTS_WRITTEN];
}

-(int) numReps;
-(const char **) theReps;
-(const char *)	theRepForFormat: (int) theformat;
-setTheRep: (const char *) newRep forFormat: (int) newFormat;
-setRep: (int) forFormat fromStream: (NXStream *)stream length:(int)length;

+ toolAwake:theApp;
- init;
- free;
- initFromPboard:thePB inDoc:theDoc linked:(BOOL) linked;
- writeComponentToPath:(NXAtom)path inFormat:(int) theFormat;
- readRichText:(NXStream *)stream forView:view;
- writeRichText:(NXStream *)stream forView:view;
- writeASCIIRef:(NXStream *)stream forView:view;
- writeLaTeX:(NXStream*)stream forView:view;
- writeHTML:(NXStream *)stream forView:view;
- inspect:(NXEvent *) e;
- drag: (Pasteboard *)draggingPboard image:(NXImage **)proxyImage;

@end

@interface eTISINDEXLiteral:eTLiteral
- initFromPboard:thePB inDoc:theDoc linked:(BOOL) linked;
@end