///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTNote.h 
//	SUMMARY:	Interface for Notes; a rtf-container
//	SUPERCLASS:	eTImage
//	INTERFACE:	None
//	PROTOCOLS:	<Tool, Annotation, ASCIISupport, InspectableTarget>
//	AUTHOR:		Rohit Khare and Tom Zavica
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//  DESCRIPTION
//		Container of rtf comment, owner, and last-modified date strings.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	10/30/94:	Modified to support <InspectableTarget>
//	07/24/94:	Converted to eTImage by RK and TRZ
//  07/07/94:	Converted to imageAnnotation by RK and TRZ 
//  07/03/94:   Member types to char*,char[],char[]. HTMDSupport added.
//	05/22/94:	Created. First actual implementation.
///////////////////////////////////////////////////////////////////////////////

#import "../eTextKernel.h"
#import "../eTImage.subproj/eTImage.h"
#import "../eTImage.subproj/eTImageUI.h"
#import "eTNoteUI.h"

@interface eTNote:eTImage <Tool,Annotation,ASCIISupport,HTMDSupport>
{
	char *RTFRep,date[64],writer[128]; // 64 should be replaced by MAXDATESIZE
}

- (const char *)RTFRep;
- setRTFRep:(const char *)newRep;
- (const char *)owner;
- setOwner:(const char *)newOwner;
- (const char *)date;
@end